package wyklad.wyklad1.editor;

import javax.swing.*;
import javax.swing.text.DefaultEditorKit;
import javax.swing.text.JTextComponent;
import javax.swing.text.StyledEditorKit;
import java.awt.*;
import java.io.IOException;
import java.net.URL;
import java.util.HashMap;

/**
 * Created by: Jacek Bzdak
 */
public class EditorFrame extends JFrame{

   private final JEditorPane editorPane;

   public EditorFrame() throws HeadlessException, IOException {


      editorPane = new JEditorPane();
      URL resource = getClass().getResource("javawiki.html");
//      URL resource = new URL("http://en.wikipedia.org/wiki/Java_(programming_language)");
      editorPane.setPage(resource);

      JMenuBar jMenuBar = new JMenuBar();
      JMenu jMenu = new JMenu("Format");

      Action action = new StyledEditorKit.BoldAction();
      action.putValue(Action.NAME, "Bold");

      jMenu.add(action);
      jMenuBar.add(jMenu);
      setJMenuBar(jMenuBar);

      add(new JScrollPane(editorPane));

   }

   private HashMap<Object, Action> createActionTable(JTextComponent textComponent) {
      HashMap<Object, Action> actions = new HashMap<Object, Action>();
      Action[] actionsArray = textComponent.getActions();
      for (int i = 0; i < actionsArray.length; i++) {
         Action a = actionsArray[i];
         actions.put(a.getValue(Action.NAME), a);
      }
      return actions;
   }

   private Action getActionByName(String name) {
      return createActionTable(editorPane).get(name);
   }




   public static void main(String[] args) throws Exception{
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            try {
               EditorFrame tf = new EditorFrame();
               tf.setSize(640, 480);
               tf.setVisible(true);
            } catch (IOException e) {
               throw new RuntimeException(e);
            }
         }
      });
   }
}
