package wyklad.wyklad2.x01innerClass;

import javax.swing.*;
import java.awt.*;

/**
 *
 * To demo pokazuje przykłąd wykorzystania SpringLayouta. Dokładne instrukcje:
 * http://docs.oracle.com/javase/tutorial/uiswing/layout/spring.html.
 * Created by: Jacek Bzdak
 */
public class ListenerShowcaseBase extends JFrame{

   protected JButton button1, button2;



   public ListenerShowcaseBase() throws HeadlessException {

      setDefaultCloseOperation(DISPOSE_ON_CLOSE);
      setTitle(getClass().getSimpleName());
      setSize(500, 200);
      button1 = new JButton("Button 1");
      button2 = new JButton("Button 2");


      JLabel label = new JLabel("Demo");

      SpringLayout springLayout = new SpringLayout();
      setLayout(springLayout);

      add(button1);

      add(button2);

      add(label);
      
      /*
         Ten layout definiowany jest za pomocą sprężyn. Srężyna umocowana jest między dwoma komponentami i ustawia 
         ich pozycje względem siebie.
       */
      

      // Ustawiamy JLabel 10 px pod górną ramką okna
      // contentPane (pobierany metodą getContentPane to wewnętrzny panel na którym mieszczą sie komponenty
      // w ramce
      springLayout.putConstraint(SpringLayout.NORTH, label, 10, SpringLayout.NORTH, getContentPane());


      // Ustawiamy oba guziki 10 pod dolną granicą jlabel
      springLayout.putConstraint(SpringLayout.NORTH, button1, 10, SpringLayout.SOUTH, label);
      springLayout.putConstraint(SpringLayout.NORTH, button2, 10, SpringLayout.SOUTH, label);

      // Ustawiamy lewą krawędź guzika od lewej krawędzi okna
      springLayout.putConstraint(SpringLayout.WEST, button1, 10, SpringLayout.WEST, getContentPane());
      // Ustawiamy lewą krawędź guzika  10px od prwej krawędzi guzika 1
      springLayout.putConstraint(SpringLayout.WEST, button2, 10, SpringLayout.EAST, button1);


   }

   public static void main(String[] args) {
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            ListenerShowcaseBase frame = new ListenerShowcaseBase();
            frame.setVisible(true);
         }
      });
   }
}
