package wyklad.wyklad2.x01innerClass;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 *
 * Tak samo jak ExternalListener, z tym że tutaj klasa listenera jest zdefiniowana w tym samym pliku.
 * Created by: Jacek Bzdak
 */
public class x2NonPublicListener extends ListenerShowcaseBase{

   public x2NonPublicListener() throws HeadlessException {
      button1.addActionListener(new NonPublicExternalListener(this, Color.GREEN));
      button2.addActionListener(new NonPublicExternalListener(this, Color.RED));
   }

   public static void main(String[] args) {
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            x2NonPublicListener frame = new x2NonPublicListener();
            frame.setVisible(true);
         }
      });
   }
}

class NonPublicExternalListener  implements ActionListener {

   final ListenerShowcaseBase parent;

   final Color color;

   public NonPublicExternalListener(ListenerShowcaseBase parent, Color color) {
      this.parent = parent;
      this.color = color;
   }

   public void actionPerformed(ActionEvent e) {
      parent.getContentPane().setBackground(color);
   }
}
