package wyklad.wyklad2.x01innerClass;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**                    
 * Tutaj listener jest zdefiniowany wewnątrz naszej klasy. Instancje klas wewnętrznych mają automatycznie wskaźnik 
 * do klasy zewnętrznej. Dodatkowo klasy wewnętrzne mają prawo do dostępu do prywatnych zmiennych kalsy matki
 * (i vice werso!).
 *
 * Created by: Jacek Bzdak
 */
public class x3InnerClassListener extends ListenerShowcaseBase{
    
    
   private int useCount;

   public x3InnerClassListener() throws HeadlessException {
      button1.addActionListener(new InternalListener(Color.GREEN));
      button2.addActionListener(new InternalListener(Color.RED));
   }
   
   class InternalListener implements ActionListener{

      final Color color;

      InternalListener(Color color) {
         this.color = color;
      }

      public void actionPerformed(ActionEvent e) {
         /**Wskaźnik na this z klasy x3InnerClassListener został autpomatycznie przekazany do instancji
          InternalListener.

          Dodatkowo nie musimy korzystać z x3InnerClassListener.this, tj. w tym przypadku samo getContentPane też
          by zadziałało.

          */
         x3InnerClassListener.this.getContentPane().setBackground(color);         
//         getContentPane().setBackground(color);

         useCount++; // Mamy dostęp do tej zmiennej!

      }
   }

   public static void main(String[] args) {
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            x3InnerClassListener frame = new x3InnerClassListener();
            frame.setVisible(true);
         }
      });
   }
}
