package wyklad.wyklad2.x055buttons;


import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

public class CheckboxFrame extends JFrame{

    static final String[] ADJECTIVES = {"Super", "ekstra", "hiper", "mega", "jazzy", "total"};

    JLabel description = new JLabel();

    // Tak na marginesie: selected jest domyślnie false
    boolean selected[] = new boolean[ADJECTIVES.length];

    // Inicjowane na null
    JCheckBox checkboxes[] = new JCheckBox[ADJECTIVES.length];
    
    public CheckboxFrame() throws HeadlessException {

        setLayout(new GridLayout(ADJECTIVES.length + 2, 1));
        
        add(description);

        for (int ii = 0; ii < ADJECTIVES.length; ii++) {
            JCheckBox checkbox = new JCheckBox();
            checkboxes[ii] = checkbox;
            checkbox.setText(ADJECTIVES[ii]);
            checkbox.addItemListener(new CheckboxListener(ii));
            add(checkbox);
        }

        JButton dialogButton = new JButton("Pokaż okienko");

        add(dialogButton);

        dialogButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String opis = "Użyto określeń: ";

                for (int i = 0; i < checkboxes.length; i++) {
                    JCheckBox checkbox = checkboxes[i];
                    if(checkbox.isSelected()){
                        opis+=checkbox.getText();
                        opis+=", ";
                    }
                }

                opis+=".";
                
                JOptionPane.showMessageDialog(CheckboxFrame.this, opis, "Wiadomość" , JOptionPane.INFORMATION_MESSAGE);
            }
        });
        pack();
 
    }

    private String buildOpis(){
        String description = "Program dla "; 
        for (int ii = 0; ii < ADJECTIVES.length; ii++) {
            if (selected[ii]){
                description+=ADJECTIVES[ii];
            }
        }
        // Uwaga tak nie powinnos się dodawać stringów! Operator += powoduje nową allokację, obiektu string. 
        // Tutaj nas to nie zabije, ale jak description zajmowałby 100MB to program by bardzo zwolnił! 
        // Poprawnie byłoby skorzystać z instancji klasy StringBuilder
        description += " Studentów!";
        this.description.setText(description);
        return description;
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                CheckboxFrame frame = new CheckboxFrame();
                frame.pack();
                frame.setVisible(true);
            }
        });
    }


    class CheckboxListener implements ItemListener{

        final int index;

        CheckboxListener(int index) {
            this.index = index;
        }


        @Override
        public void itemStateChanged(ItemEvent e) {
            selected[index] = e.getStateChange() == ItemEvent.SELECTED;
            buildOpis();
        }
    }
}
