package wyklad.wyklad2.x06dialogs;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.charset.Charset;

/**
 *
 * Pokaz wszystkich dialogów które można łatowo powoływać z Jawy.Bardziej zaawansowane możliwości dostepne są poprzez
 * własnoręczne implementowanie klasy JDialog.
 *
 * Created by: Jacek Bzdak
 */
public class DialogFrame extends JFrame{

	public DialogFrame() throws HeadlessException {
      
      setLayout(new FlowLayout());

      setDefaultCloseOperation(DISPOSE_ON_CLOSE);

      setSize(640, 480); 
      
      JButton m1 = new JButton("Message 1");
      m1.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {

            /**
             *   Argumenty po kolei:
             *
             *   Ramka która jets właścicielem dialoga, może być null
             *   Wiadomość
             *   Tytuł dialoga
             *   rodzaj wiadomości
             */
            JOptionPane.showMessageDialog(DialogFrame.this, "Kliknąłeś guzik", "Wiadomość", JOptionPane.INFORMATION_MESSAGE);
         }
      });

      JButton m3 = new JButton("Wybór");
      
      m3.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            int result = JOptionPane.CANCEL_OPTION;
            do{
               result = JOptionPane.showConfirmDialog(null, "Kliknij tak!", "Prośba", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
            }while (result!=JOptionPane.YES_OPTION);
         }
      });
      
      
      JButton m4 = new JButton("Wpisz coś");
      
      m4.addActionListener(new ActionListener() {
    	  
         public void actionPerformed(ActionEvent e) {            
            Object result = JOptionPane.showInputDialog(DialogFrame.this, "Wpisz 'bazbarfoo'");
            if(!"bazbarfoo".equals(result)){
               JOptionPane.showMessageDialog(DialogFrame.this, "Wpisałeś coś innego!", "Błąd", JOptionPane.ERROR_MESSAGE);;
            }
         }
         
      });
      
      JButton m5 = new JButton("Wybierz");
      m5.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
           Object[] selection = new Object[]{"bazbarfoo", "foobarbaz", "barbazfoo"};
           Object result = JOptionPane.showInputDialog(DialogFrame.this, "Wybierz 'bazbarfoo'", "Prośba", 
        		   		JOptionPane.QUESTION_MESSAGE,
        		   		null, selection, selection[1]);
           if (result == null){        	   
        	   JOptionPane.showMessageDialog(DialogFrame.this, "Wybrałeś cancel!", "Błąd", JOptionPane.ERROR_MESSAGE);;        	   
        	   return;
           }
           if(!"bazbarfoo".equals(result)){
              JOptionPane.showMessageDialog(DialogFrame.this, "Wybrałeś coś innego!", "Błąd", JOptionPane.ERROR_MESSAGE);;
           }
        }
     });
     
      
      JButton color = new JButton("Kolor");

      color.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            Color color = JColorChooser.showDialog(DialogFrame.this, "Wybierz tło", DialogFrame.this.getContentPane().getBackground());
            DialogFrame.this.getContentPane().setBackground(color);
         }
      });
      
      JButton chooser = new JButton("File chooser");
      
      chooser.addActionListener(new ButtonListener());

       JButton disabled = new JButton("Wyłączony");
       disabled.setEnabled(false);
       disabled.addActionListener(new ActionListener() {
           @Override
           public void actionPerformed(ActionEvent e) {
               System.exit(0); /// Nie wykona się
           }
       });


      
      add(m1);
//*/      add(m2);
      add(m3);
      add(m4);
      add(m5);
      add(color);
      add(chooser);
      add(disabled);
   }
   
   private final class ButtonListener implements ActionListener {
		
	   JFileChooser fileChooser = new JFileChooser();

		public void actionPerformed(ActionEvent e) {
           fileChooser.showDialog(DialogFrame.this, "Zapisz tajną wiadomość");
           File file = fileChooser.getSelectedFile(); 
           
           if (file.exists()){
              JOptionPane.showMessageDialog(DialogFrame.this, "Nie nadpiszę instniejącego pliku", "Błąd", JOptionPane.ERROR_MESSAGE);
           }else {
              FileOutputStream stream = null;
              try {
                 stream = new FileOutputStream(file);
                 stream.write("Tajna wiadomość".getBytes(Charset.defaultCharset()));
              } catch (IOException e1) {
                 JOptionPane.showMessageDialog(DialogFrame.this, "Błąd zapisu " + e1.getMessage(), "Błąd", JOptionPane.ERROR_MESSAGE);                  
              }finally {
                 if(stream != null){
                    try {
                       stream.close();
                    } catch (IOException e1) {
                         //ignore                        
                    }
                 }
              }
           }
        }
	}

   public static void main(String[] args) {
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            DialogFrame frame = new DialogFrame();
            frame.setVisible(true);
         }
      });
   }
}
